/******************************************************************************
 * scene.h 
 * implements the scene management class
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/

#ifndef SCENE_H
#define SCENE_H

#include <string>
#include <list>

// ------------------------------------------------------------
// forward declarations
//

class CMesh;

// ------------------------------------------------------------
// defines thes scene class
// 

class CScene
{
	//constructor/destructor
	CScene();
	~CScene();

	// member variables
	static CScene* m_pInstance;
	std::list<CMesh*> m_listMeshes;

	bool m_bShadowsEnabled;

public:
	// destroys the single scene
	static void destroyScene();

	//gets the single scene
	static CScene* getScene();

	// adds a mesh to the scene
	CMesh* addMesh(std::string& objFilename);

	void drawMeshes() const;

	// gets all the meshes in the scene
	std::list<CMesh*>& getMeshes();

	bool getShadowsEnabled() const;
};

#endif
